> For the complete documentation index, see [llms.txt](https://docs.pay.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pay.io/api-reference/core-concepts/request-structure.md).

# Request Structure

### Request URL structure <a href="#request-url-structure" id="request-url-structure"></a>

Pay.io APIs use a straightforward URL naming convention, consisting of two parts, a **base URL** and **endpoint path**.

#### Base URL for API requests in staging environment <a href="#base-urls-for-api-requests" id="base-urls-for-api-requests"></a>

<pre><code><strong>https://gateway.stage.pay.io/
</strong></code></pre>

**Request structure example**

Structure

```
https://{base-url}/{endpoint-path}
```

Example full request URL for staging environment

```
https://gateway.stage.pay.io/v1/merchant/currencies
```

***

### Required Headers

* `X-API-Key`: Your unique API key obtained from your account settings in Merchant Console or provided by support team.
* `X-API-Nonce`: A unique identifier (UUID) for each request to prevent replay attacks. See [Creating a Merchant Signature (nonce)](/api-reference/core-concepts/authorisation.md#creating-a-merchant-signature) guide for more.&#x20;
* `X-API-Signature`: Signature generated using **RSA-SHA256**. See more in [Authorisation](/api-reference/core-concepts/authorisation.md#creating-a-public-and-private-key) guide.&#x20;


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pay.io/api-reference/core-concepts/request-structure.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
